//+------------------------------------------------------------------+
//|                           Shinigami Time-Price alert indi v2.mq4 |
//|                                                     by Shinigami |
//|                                              Shini1984@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, Shinigami"
#property link      "Shini1984@gmail.com"

#property  indicator_chart_window
#property  indicator_buffers 0
#property indicator_color1 Yellow
#property indicator_width1 0

extern double Target_price = 1.1; // target price
extern int Direction = 1; // 0 - disabled, 1 - higher than target, -1 - lower than target
extern bool Auto_reset = true; // automatically reset every bar or every day
extern int Mode = 2; // mode 
// put 2 in Mode_2_Minutes to make it sound 2 minutes after bar starts
// put -3 in Mode_2_Minutes to make it sound 3 minutes before bar ends
extern string Mode_1_Time = "12:32 | 06:43 | 17:30 | 21:25 | 13:03";
extern int Mode_2_Minutes = 2; // alert X minutes before bar ends
extern int Repeats = 1; // number of times alert is played
extern int Pause = 1; // pause in seconds between alerts
extern int Start_hour = 0; // starting hour for alerts, inclusive
extern int End_hour = 23; // ending hour for alerts, exclusive
extern bool Show_settings_on_chart = true;
extern string Mail_subject = "Alert! Check MT4!";
extern string Mail_text = "Alert!"; // some info is added afterwards
extern string mode_line1 = "Available modes:";
extern string mode_line2 = " 0 - alert is disabled";
extern string mode_line3 = " 1 - alert at Exact hour : minute";
extern string mode_line4 = " 2 - alert X minutes before or after bar ends";
extern string Alert_file = "Alert.wav";
extern color Signal_UP = Lime;
extern color Signal_DOWN = Red;
extern int Custom_digits = -1; // any value higher than -1 = use this value for Digits
extern int font_size = 14;
extern color box_color = Black;
extern bool show_all_times = false; // shows all times for mode 1
extern string separator_symbol = "|";
int xbox=13; // number of black boxes in X axis (in a row)
int ybox=5; // number of black boxes in Y axis (in a column)


int hour[20],minute[20];
bool started=false;
int alerted=0;
datetime last_played=0,now=0;
//int Ex_Hour=-1,Ex_Min=-1;
int d=0;

//================================================================================================+
int init()
{
for(int i=0;i<=19;i++)
{ hour[i]=-1; }
if(Mode_2_Minutes<0)
{
   if(MathAbs(Mode_2_Minutes)<=Period()) { Mode_2_Minutes=Period()+Mode_2_Minutes; }
   else Mode_2_Minutes=0;
}
d=Digits;
if(d==3||d==5) d--;
if(Custom_digits>=0) d=Custom_digits;
if(Pause<1) Pause=1;
if(Pause>5) Pause=5;
if(Repeats<1) Repeats=1;
if(Repeats>10) Repeats=10;
return(0);
}
//================================================================================================+
int deinit()
{
ObjectDelete("Target");
ObjectDelete("AlertState");
ObjectDelete("Mode_Time");
ObjectDelete("Contact1");
ObjectDelete("Contact2");
alerted=0;
started=false;
last_played=0;
//Ex_Hour=-1;
//Ex_Min=-1;
now=0;
Comment("");
for(int x=0;x<xbox;x++) {
 for(int y=0;y<ybox;y++) { ObjectDelete("a"+x+y); } }
return(0);
}
//================================================================================================+
int start()
{

RefreshRates();
if(Mode==1 && hour[0]==-1) DefineTime();

bool alert_allowed=true;
if(Start_hour<End_hour)
{
   if(Hour()<Start_hour || Hour()>=End_hour) alert_allowed=false;
}
if(Start_hour>End_hour)
{
   if(Hour()>=End_hour && Hour()<Start_hour) alert_allowed=false;
}
if(Start_hour==End_hour && Start_hour==Hour()) alert_allowed=true;

if(Auto_reset && alerted>=Repeats)
{
   if(Mode==2) 
   {
      if(now!=Time[0])
      {
         now=Time[0];
         alerted=0; started=false; last_played=0;
      }
      else return(0);
   }
   if(Mode==1)
   {
      if(now!=iTime(Symbol(),PERIOD_D1,0))
      {
         now=iTime(Symbol(),PERIOD_D1,0);
         alerted=0; started=false; last_played=0;
      }
      else return(0);
   }
}

int p=Period(),min_passed=0;
while(p<=Mode_2_Minutes) { Mode_2_Minutes-=p; }

int i=0,desired_minutes=0;

int res=0;
if(Period()>1) {
   if(Period()<=60) {
      for(i=0;i<60/Period();i++)
      {
         desired_minutes=Period()*i+Mode_2_Minutes;
         if(desired_minutes>Minute()) break;
      }
   }
   else
   {
      desired_minutes=Mode_2_Minutes-60*MathFloor(Mode_2_Minutes/60);
   }
}

if(alert_allowed)
{
   if(Mode==1 && Check_Time())
   {
      if(Direction>0 && Bid > Target_price) PlayAlert();
      if(Direction<0 && Bid < Target_price) PlayAlert();
   }
   if(Mode==2)
   {
      if(p<=60)
      {
         if(Minute()==desired_minutes)
         {
            if(Direction>0 && Bid > Target_price) PlayAlert();
            if(Direction<0 && Bid < Target_price) PlayAlert();
         }
      }
      else
      {
         if(Mode_2_Minutes>60)
         {
            min_passed=(Hour()-TimeHour(Time[0]))*60+Minute();
            if(Mode_2_Minutes==min_passed)
            {
               if(Direction>0 && Bid > Target_price) PlayAlert();
               if(Direction<0 && Bid < Target_price) PlayAlert();
            }
         }
      }
   }
}

if(Show_settings_on_chart)
{
   string next_alert=Find_next_alert();
   string condition="Waiting for alert",dir_str="DOWN",mode_str="";
   if(Mode==1) mode_str="Mode: 1, time: "+next_alert;
   if(Mode==2) mode_str="Mode: 2, minutes: "+Mode_2_Minutes;
   if(Direction>0) dir_str="UP";
   if(started) condition="Alert!!!";
   if(alerted>=Repeats) { condition="Alerted."; if(Auto_reset) condition=condition+" Waiting on next bar."; }
   if(!alert_allowed) condition="Sleeping...z-z-z....";
   ShowSettings(condition,mode_str);
   Box();
}

return(0);
}
//================================================================================================+
void DefineTime()
{
int i=0,number=0;
string time_str=Mode_1_Time;
time_str=separator_symbol+time_str;

int len=StringLen(time_str);
for(i=len;i>=0;i--)
{
   if(StringSubstr(time_str,i-1,1)==" ")
   {
      time_str=StringSubstr(time_str,0,i-1)+StringSubstr(time_str,i);
   }
}
len=StringLen(time_str);

for(i=0;i<=len;i++)
{
   if(StringSubstr(time_str,i,1)==separator_symbol)
   {
      if(StringSubstr(time_str,i+2,1)==":")
      {
         hour[number]=StrToInteger(StringSubstr(time_str,i+1,1));
         minute[number]=StrToInteger(StringSubstr(time_str,i+3,2));
         number++;
         if(number==19) break;
      }
      if(StringSubstr(time_str,i+3,1)==":")
      {
         hour[number]=StrToInteger(StringSubstr(time_str,i+1,2));
         minute[number]=StrToInteger(StringSubstr(time_str,i+4,2));
         number++;
         if(number==19) break;
      }
   }
}
SortMe();
// this piece shows a long line of numbers: sorted hours and minutes, in ascending order, including unused times

if(show_all_times) {
string times="";
for(i=0;i<=19;i++)
{
   times=times+hour[i]+":"+minute[i]+"\n";
}
Comment("Times are: "+times);
}
return;
}
//================================================================================================+
void SortMe()
{
bool changes;
int h=0,m=0;
while(true)
{
   changes=false;
   for(int i=0;i<=18;i++)
   {
      if(hour[i+1]==-1) continue;
      if(hour[i]>hour[i+1])
      {
         h=hour[i]; m=minute[i]; hour[i]=hour[i+1]; minute[i]=minute[i+1]; hour[i+1]=h; minute[i+1]=m; changes=true;
      }
      if(hour[i]==hour[i+1] && minute[i]>minute[i+1])
      {
         h=hour[i]; m=minute[i]; hour[i]=hour[i+1]; minute[i]=minute[i+1]; hour[i+1]=h; minute[i+1]=m; changes=true;
      }
   }
   if(changes==false) return; // if no changes are done in an entire run, its all sorted.
}
return;
}
//================================================================================================+
string Find_next_alert()
{
for(int i=0;i<=19;i++)
{
   if(hour[i]>=Hour() && minute[i]>=Minute()) return(hour[i]+":"+minute[i]);
}
return(hour[0]+":"+minute[0]); // if no other time returned: return first time
}
//================================================================================================+
bool Check_Time()
{
for(int i=0;i<=19;i++)
{
   if(hour[i]==Hour() && minute[i]==Minute()) return(true);
}
return(false);
}
//================================================================================================+
void PlayAlert()
{
RefreshRates();
while(alerted < Repeats)
{
   if(TimeCurrent()>=last_played+Pause)
   {
      Alert(Symbol()+": Reached Target! _ "+DoubleToStr(Target_price,d)+" _ "+(alerted+1));
      PlaySound(Alert_file);
      last_played=TimeCurrent();
      now=Time[0];
      alerted++;
      SendMail(Mail_subject,Mail_text+" "+Symbol()+": reached target:"+DoubleToStr(Target_price,d)+" dir:"+Direction);
   }
}

return;
}
//================================================================================================+
void ShowSettings(string cond, string mode_explanation)
{
if(ObjectFind("Target")==-1)
{
color color_dir;
if(Direction>0) color_dir=Signal_UP;
else if(Direction<0) color_dir=Signal_DOWN;
else color_dir=Gray;
   ObjectCreate("Target",OBJ_LABEL,0,1,1);
   ObjectSetText("Target","Target price: "+DoubleToStr(Target_price,d),font_size,"Tahoma",color_dir);
   ObjectSet("Target",OBJPROP_XDISTANCE,10);
   ObjectSet("Target",OBJPROP_YDISTANCE,10);

   ObjectCreate("AlertState",OBJ_LABEL,0,1,1);
   ObjectSetText("AlertState",cond,font_size,"Tahoma",color_dir);
   ObjectSet("AlertState",OBJPROP_XDISTANCE,10);
   ObjectSet("AlertState",OBJPROP_YDISTANCE,10+font_size*1.6);

   ObjectCreate("Mode_Time",OBJ_LABEL,0,1,1);
   ObjectSetText("Mode_Time",mode_explanation,font_size,"Tahoma",color_dir);
   ObjectSet("Mode_Time",OBJPROP_XDISTANCE,10);
   ObjectSet("Mode_Time",OBJPROP_YDISTANCE,10+font_size*1.6*2);

   ObjectCreate("Contact1",OBJ_LABEL,0,1,1);
   ObjectSetText("Contact1","Made by Shinigami A.K.A. Yuri",8,"Tahoma",Gray);
   ObjectSet("Contact1",OBJPROP_XDISTANCE,10);
   ObjectSet("Contact1",OBJPROP_YDISTANCE,10+font_size*1.6*3);

   ObjectCreate("Contact2",OBJ_LABEL,0,1,1);
   ObjectSetText("Contact2","Contact me: Shini1984@gmail.com",8,"Tahoma",Gray);
   ObjectSet("Contact2",OBJPROP_XDISTANCE,10);
   ObjectSet("Contact2",OBJPROP_YDISTANCE,10+font_size*1.6*3+12);
}
return;
}
//================================================================================================+
int Box()
{
for(int x=0;x<xbox;x++) {
for(int y=0;y<ybox;y++) {
 ObjectCreate("a"+x+y,OBJ_LABEL,0,0,0,0,0);
 ObjectSet("a"+x+y,OBJPROP_XDISTANCE,x*19);
 ObjectSet("a"+x+y,OBJPROP_YDISTANCE,6+y*19);
 ObjectSetText("a"+x+y,CharToStr(110),25,"Wingdings",box_color); } }
return(0);
}
//================================================================================================+
//================================================================================================+
//================================================================================================+
//================================================================================================+

